/**
* Nudsf_DataRepository
* Nudsf Data Repository Service. © 2021, 3GPP Organizational Partners (ARIB, ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved. 
*
* The version of the OpenAPI document: 1.1.0-alpha.2
* 
*
* NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
* https://openapi-generator.tech
* Do not edit the class manually.
*/

#include "DataExposure.h"
//#include "Helpers.h"
#include "logger.hpp"
#include <nlohmann/json.hpp>
//#include "TransData.hpp"
#include <stdlib.h>
#include <map>
#include <algorithm>
#include <cmath>

#include "smf_context.hpp"

extern std::vector<struct sessions_data> sess_data;

using json = nlohmann::json;


//using namespace org::openapitools::server::model;

namespace oai {
namespace smf_server {
namespace api {

//using namespace oai::smf_server::model;



DataExposureApi::DataExposureApi(std::shared_ptr<Pistache::Rest::Router> rtr) { 
    router = rtr;
}

void DataExposureApi::init() {
    setupRoutes();
}

void DataExposureApi::setupRoutes() {
    using namespace Pistache::Rest;

    Routes::Get(*router, base + "/getNFService", Routes::bind(&DataExposureApi::getNFService, this));
}

void DataExposureApi::getNFService(const Pistache::Rest::Request &request, Pistache::Http::ResponseWriter response) {
    
    printf("getNFService\n");
    try {
	json resp;
	json ues;
	for(int i=0;i<sess_data.size();i++){
	  ues["supi"] = sess_data[i].supi;
	  ues["pdu_session_id"] = sess_data[i].pdu_sess_id;
	  ues["snssai"]["sst"] = sess_data[i].sst;
	  ues["snssai"]["sd"] = sess_data[i].sd;
	  ues["pdu_session_type"] = sess_data[i].pdu_sess_type;
	  ues["ip_address"] = sess_data[i].ip;
	  ues["dnn"] = sess_data[i].dnn;
	  resp["ues"].push_back(ues);
	}
	printf("response: %s\n",resp.dump().c_str());
	response.send(Pistache::Http::Code::Ok, resp.dump().c_str());
	return;
    } catch (nlohmann::detail::exception &e) {
        //send a 400 error
        response.send(Pistache::Http::Code::Bad_Request, e.what());
        return;
    } catch (Pistache::Http::HttpError &e) {
        response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
        return;
    } catch (std::exception &e) {
        //send a 500 error
        response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
        return;
    }
}
}
}
}


